<?php 
require_once '../vendor/autoload.php';

use Kreait\Firebase\Factory;
use Kreait\Firebase\ServiceAccount;
use Kreait\Firebase\Auth;

$factory = (new Factory)->withServiceAccount('../service_account_key.json');
$auth = $factory->createAuth();

$status = false;

$msg = '';

// Define the date range for the current month
$currentMonthStart = new DateTime('first day of this month 00:00:00');
$currentMonthEnd = new DateTime('last day of this month 23:59:59');

// Fetch all users
$users = $auth->listUsers();

// Initialize counter for active users
$monthlyActiveUsers = 0;

$activeUserTimestamp = [];

$dateWiseCount=[];

foreach ($users as $user) {
    if ($user->metadata->lastLoginAt) {
        $lastSignInAt = $user->metadata->lastLoginAt;
        if ($lastSignInAt >= $currentMonthStart && $lastSignInAt <= $currentMonthEnd) {
            $loginDate = $lastSignInAt->format('Y-m-d');
            if (!isset($dateWiseCount[$loginDate])) { 
                $dateWiseCount[$loginDate] = 0; 
            } 
            $monthlyActiveUsers++;
            $dateWiseCount[$loginDate]++;
            $dateOnly = DateTime::createFromFormat('Y-m-d', $loginDate);
            $timestamp = $dateOnly->getTimestamp()*1000;
            $activeUserCountTimestamp =[$timestamp,$dateWiseCount[$loginDate]];
            array_push($activeUserTimestamp,$activeUserCountTimestamp);
        }

        
    }
}

usort($activeUserTimestamp, function($a, $b) {
    return $a[0] <=> $b[0];
});

// Sort by date in ascending order 


if(!empty($activeUserTimestamp)){
    $status =true;
    $myObj = [ 'status' => $status,'count'=>$monthlyActiveUsers,'timestamps'=>$activeUserTimestamp,'startDate'=>$currentMonthStart->getTimestamp()*1000,'endDate'=>$currentMonthEnd->getTimestamp()*1000];
}else{
    $myObj = [ 'status' => $status];
}



header('Content-type: application/json');
echo json_encode($myObj);

?>